// Code generated by protoc-gen-go. DO NOT EDIT.
// versions:
// 	protoc-gen-go v1.36.2
// 	protoc        (unknown)
// source: gateway/rooms/v1/rooms.proto

package roomsv1

import (
	protoreflect "google.golang.org/protobuf/reflect/protoreflect"
	protoimpl "google.golang.org/protobuf/runtime/protoimpl"
	durationpb "google.golang.org/protobuf/types/known/durationpb"
	timestamppb "google.golang.org/protobuf/types/known/timestamppb"
	reflect "reflect"
	sync "sync"
)

const (
	// Verify that this generated code is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(20 - protoimpl.MinVersion)
	// Verify that runtime/protoimpl is sufficiently up-to-date.
	_ = protoimpl.EnforceVersion(protoimpl.MaxVersion - 20)
)

type DifficultyLevel int32

const (
	DifficultyLevel_DIFFICULTY_LEVEL_UNSPECIFIED DifficultyLevel = 0
	DifficultyLevel_DIFFICULTY_LEVEL_EASY        DifficultyLevel = 1
	DifficultyLevel_DIFFICULTY_LEVEL_MEDIUM      DifficultyLevel = 2
	DifficultyLevel_DIFFICULTY_LEVEL_HARD        DifficultyLevel = 3
)

// Enum value maps for DifficultyLevel.
var (
	DifficultyLevel_name = map[int32]string{
		0: "DIFFICULTY_LEVEL_UNSPECIFIED",
		1: "DIFFICULTY_LEVEL_EASY",
		2: "DIFFICULTY_LEVEL_MEDIUM",
		3: "DIFFICULTY_LEVEL_HARD",
	}
	DifficultyLevel_value = map[string]int32{
		"DIFFICULTY_LEVEL_UNSPECIFIED": 0,
		"DIFFICULTY_LEVEL_EASY":        1,
		"DIFFICULTY_LEVEL_MEDIUM":      2,
		"DIFFICULTY_LEVEL_HARD":        3,
	}
)

func (x DifficultyLevel) Enum() *DifficultyLevel {
	p := new(DifficultyLevel)
	*p = x
	return p
}

func (x DifficultyLevel) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (DifficultyLevel) Descriptor() protoreflect.EnumDescriptor {
	return file_gateway_rooms_v1_rooms_proto_enumTypes[0].Descriptor()
}

func (DifficultyLevel) Type() protoreflect.EnumType {
	return &file_gateway_rooms_v1_rooms_proto_enumTypes[0]
}

func (x DifficultyLevel) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use DifficultyLevel.Descriptor instead.
func (DifficultyLevel) EnumDescriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{0}
}

type RoomStatus int32

const (
	RoomStatus_ROOM_STATUS_UNSPECIFIED RoomStatus = 0
	RoomStatus_ROOM_STATUS_WAITING     RoomStatus = 1
	RoomStatus_ROOM_STATUS_STARTING    RoomStatus = 2
	RoomStatus_ROOM_STATUS_PLAYING     RoomStatus = 3
	RoomStatus_ROOM_STATUS_ENDING      RoomStatus = 4
)

// Enum value maps for RoomStatus.
var (
	RoomStatus_name = map[int32]string{
		0: "ROOM_STATUS_UNSPECIFIED",
		1: "ROOM_STATUS_WAITING",
		2: "ROOM_STATUS_STARTING",
		3: "ROOM_STATUS_PLAYING",
		4: "ROOM_STATUS_ENDING",
	}
	RoomStatus_value = map[string]int32{
		"ROOM_STATUS_UNSPECIFIED": 0,
		"ROOM_STATUS_WAITING":     1,
		"ROOM_STATUS_STARTING":    2,
		"ROOM_STATUS_PLAYING":     3,
		"ROOM_STATUS_ENDING":      4,
	}
)

func (x RoomStatus) Enum() *RoomStatus {
	p := new(RoomStatus)
	*p = x
	return p
}

func (x RoomStatus) String() string {
	return protoimpl.X.EnumStringOf(x.Descriptor(), protoreflect.EnumNumber(x))
}

func (RoomStatus) Descriptor() protoreflect.EnumDescriptor {
	return file_gateway_rooms_v1_rooms_proto_enumTypes[1].Descriptor()
}

func (RoomStatus) Type() protoreflect.EnumType {
	return &file_gateway_rooms_v1_rooms_proto_enumTypes[1]
}

func (x RoomStatus) Number() protoreflect.EnumNumber {
	return protoreflect.EnumNumber(x)
}

// Deprecated: Use RoomStatus.Descriptor instead.
func (RoomStatus) EnumDescriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{1}
}

type CreateRoomData struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	RoomId        string                 `protobuf:"bytes,1,opt,name=room_id,json=roomId,proto3" json:"room_id,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *CreateRoomData) Reset() {
	*x = CreateRoomData{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[0]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *CreateRoomData) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*CreateRoomData) ProtoMessage() {}

func (x *CreateRoomData) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[0]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use CreateRoomData.ProtoReflect.Descriptor instead.
func (*CreateRoomData) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{0}
}

func (x *CreateRoomData) GetRoomId() string {
	if x != nil {
		return x.RoomId
	}
	return ""
}

type CreateRoomRequest struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Name          string                 `protobuf:"bytes,1,opt,name=name,proto3" json:"name,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *CreateRoomRequest) Reset() {
	*x = CreateRoomRequest{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[1]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *CreateRoomRequest) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*CreateRoomRequest) ProtoMessage() {}

func (x *CreateRoomRequest) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[1]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use CreateRoomRequest.ProtoReflect.Descriptor instead.
func (*CreateRoomRequest) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{1}
}

func (x *CreateRoomRequest) GetName() string {
	if x != nil {
		return x.Name
	}
	return ""
}

type CreateRoomResponse struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Data          *CreateRoomData        `protobuf:"bytes,3,opt,name=data,proto3" json:"data,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *CreateRoomResponse) Reset() {
	*x = CreateRoomResponse{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[2]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *CreateRoomResponse) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*CreateRoomResponse) ProtoMessage() {}

func (x *CreateRoomResponse) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[2]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use CreateRoomResponse.ProtoReflect.Descriptor instead.
func (*CreateRoomResponse) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{2}
}

func (x *CreateRoomResponse) GetData() *CreateRoomData {
	if x != nil {
		return x.Data
	}
	return nil
}

type EditRoomRequest struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	RoomId        string                 `protobuf:"bytes,1,opt,name=room_id,json=roomId,proto3" json:"room_id,omitempty"`
	Name          string                 `protobuf:"bytes,2,opt,name=name,proto3" json:"name,omitempty"`
	MaxPlayers    uint32                 `protobuf:"varint,3,opt,name=max_players,json=maxPlayers,proto3" json:"max_players,omitempty"`
	MatchDuration *durationpb.Duration   `protobuf:"bytes,4,opt,name=match_duration,json=matchDuration,proto3,oneof" json:"match_duration,omitempty"`
	Difficulty    DifficultyLevel        `protobuf:"varint,5,opt,name=difficulty,proto3,enum=gateway.rooms.v1.DifficultyLevel" json:"difficulty,omitempty"`
	Shuffle       bool                   `protobuf:"varint,6,opt,name=shuffle,proto3" json:"shuffle,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *EditRoomRequest) Reset() {
	*x = EditRoomRequest{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[3]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *EditRoomRequest) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*EditRoomRequest) ProtoMessage() {}

func (x *EditRoomRequest) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[3]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use EditRoomRequest.ProtoReflect.Descriptor instead.
func (*EditRoomRequest) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{3}
}

func (x *EditRoomRequest) GetRoomId() string {
	if x != nil {
		return x.RoomId
	}
	return ""
}

func (x *EditRoomRequest) GetName() string {
	if x != nil {
		return x.Name
	}
	return ""
}

func (x *EditRoomRequest) GetMaxPlayers() uint32 {
	if x != nil {
		return x.MaxPlayers
	}
	return 0
}

func (x *EditRoomRequest) GetMatchDuration() *durationpb.Duration {
	if x != nil {
		return x.MatchDuration
	}
	return nil
}

func (x *EditRoomRequest) GetDifficulty() DifficultyLevel {
	if x != nil {
		return x.Difficulty
	}
	return DifficultyLevel_DIFFICULTY_LEVEL_UNSPECIFIED
}

func (x *EditRoomRequest) GetShuffle() bool {
	if x != nil {
		return x.Shuffle
	}
	return false
}

type EditRoomResponse struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *EditRoomResponse) Reset() {
	*x = EditRoomResponse{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[4]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *EditRoomResponse) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*EditRoomResponse) ProtoMessage() {}

func (x *EditRoomResponse) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[4]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use EditRoomResponse.ProtoReflect.Descriptor instead.
func (*EditRoomResponse) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{4}
}

type JoinRoomRequest struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	RoomId        string                 `protobuf:"bytes,1,opt,name=room_id,json=roomId,proto3" json:"room_id,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *JoinRoomRequest) Reset() {
	*x = JoinRoomRequest{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[5]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *JoinRoomRequest) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*JoinRoomRequest) ProtoMessage() {}

func (x *JoinRoomRequest) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[5]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use JoinRoomRequest.ProtoReflect.Descriptor instead.
func (*JoinRoomRequest) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{5}
}

func (x *JoinRoomRequest) GetRoomId() string {
	if x != nil {
		return x.RoomId
	}
	return ""
}

type LeaveRoomRequest struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	RoomId        string                 `protobuf:"bytes,1,opt,name=room_id,json=roomId,proto3" json:"room_id,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *LeaveRoomRequest) Reset() {
	*x = LeaveRoomRequest{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[6]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *LeaveRoomRequest) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*LeaveRoomRequest) ProtoMessage() {}

func (x *LeaveRoomRequest) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[6]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use LeaveRoomRequest.ProtoReflect.Descriptor instead.
func (*LeaveRoomRequest) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{6}
}

func (x *LeaveRoomRequest) GetRoomId() string {
	if x != nil {
		return x.RoomId
	}
	return ""
}

type CheckIfRoomExistsRequest struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	RoomId        string                 `protobuf:"bytes,1,opt,name=room_id,json=roomId,proto3" json:"room_id,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *CheckIfRoomExistsRequest) Reset() {
	*x = CheckIfRoomExistsRequest{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[7]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *CheckIfRoomExistsRequest) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*CheckIfRoomExistsRequest) ProtoMessage() {}

func (x *CheckIfRoomExistsRequest) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[7]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use CheckIfRoomExistsRequest.ProtoReflect.Descriptor instead.
func (*CheckIfRoomExistsRequest) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{7}
}

func (x *CheckIfRoomExistsRequest) GetRoomId() string {
	if x != nil {
		return x.RoomId
	}
	return ""
}

type CheckIfRoomExistsResponse struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Exists        bool                   `protobuf:"varint,1,opt,name=exists,proto3" json:"exists,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *CheckIfRoomExistsResponse) Reset() {
	*x = CheckIfRoomExistsResponse{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[8]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *CheckIfRoomExistsResponse) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*CheckIfRoomExistsResponse) ProtoMessage() {}

func (x *CheckIfRoomExistsResponse) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[8]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use CheckIfRoomExistsResponse.ProtoReflect.Descriptor instead.
func (*CheckIfRoomExistsResponse) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{8}
}

func (x *CheckIfRoomExistsResponse) GetExists() bool {
	if x != nil {
		return x.Exists
	}
	return false
}

type User struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	UserId        string                 `protobuf:"bytes,1,opt,name=user_id,json=userId,proto3" json:"user_id,omitempty"`
	Nickname      string                 `protobuf:"bytes,2,opt,name=nickname,proto3" json:"nickname,omitempty"`
	Emoji         string                 `protobuf:"bytes,3,opt,name=emoji,proto3" json:"emoji,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *User) Reset() {
	*x = User{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[9]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *User) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*User) ProtoMessage() {}

func (x *User) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[9]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use User.ProtoReflect.Descriptor instead.
func (*User) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{9}
}

func (x *User) GetUserId() string {
	if x != nil {
		return x.UserId
	}
	return ""
}

func (x *User) GetNickname() string {
	if x != nil {
		return x.Nickname
	}
	return ""
}

func (x *User) GetEmoji() string {
	if x != nil {
		return x.Emoji
	}
	return ""
}

type RoomData struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Name          string                 `protobuf:"bytes,1,opt,name=name,proto3" json:"name,omitempty"`
	HostId        string                 `protobuf:"bytes,2,opt,name=host_id,json=hostId,proto3" json:"host_id,omitempty"`
	MaxPlayers    int32                  `protobuf:"varint,3,opt,name=max_players,json=maxPlayers,proto3" json:"max_players,omitempty"`
	QuestionCount int32                  `protobuf:"varint,4,opt,name=question_count,json=questionCount,proto3" json:"question_count,omitempty"`
	RoomStatus    RoomStatus             `protobuf:"varint,5,opt,name=room_status,json=roomStatus,proto3,enum=gateway.rooms.v1.RoomStatus" json:"room_status,omitempty"`
	Users         []*User                `protobuf:"bytes,6,rep,name=users,proto3" json:"users,omitempty"`
	BannedUsers   []*User                `protobuf:"bytes,7,rep,name=banned_users,json=bannedUsers,proto3" json:"banned_users,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *RoomData) Reset() {
	*x = RoomData{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[10]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *RoomData) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*RoomData) ProtoMessage() {}

func (x *RoomData) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[10]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use RoomData.ProtoReflect.Descriptor instead.
func (*RoomData) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{10}
}

func (x *RoomData) GetName() string {
	if x != nil {
		return x.Name
	}
	return ""
}

func (x *RoomData) GetHostId() string {
	if x != nil {
		return x.HostId
	}
	return ""
}

func (x *RoomData) GetMaxPlayers() int32 {
	if x != nil {
		return x.MaxPlayers
	}
	return 0
}

func (x *RoomData) GetQuestionCount() int32 {
	if x != nil {
		return x.QuestionCount
	}
	return 0
}

func (x *RoomData) GetRoomStatus() RoomStatus {
	if x != nil {
		return x.RoomStatus
	}
	return RoomStatus_ROOM_STATUS_UNSPECIFIED
}

func (x *RoomData) GetUsers() []*User {
	if x != nil {
		return x.Users
	}
	return nil
}

func (x *RoomData) GetBannedUsers() []*User {
	if x != nil {
		return x.BannedUsers
	}
	return nil
}

type JoinRoomResponse struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	RepeatAt      *timestamppb.Timestamp `protobuf:"bytes,1,opt,name=repeat_at,json=repeatAt,proto3" json:"repeat_at,omitempty"`
	Room          *RoomData              `protobuf:"bytes,2,opt,name=room,proto3,oneof" json:"room,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *JoinRoomResponse) Reset() {
	*x = JoinRoomResponse{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[11]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *JoinRoomResponse) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*JoinRoomResponse) ProtoMessage() {}

func (x *JoinRoomResponse) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[11]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use JoinRoomResponse.ProtoReflect.Descriptor instead.
func (*JoinRoomResponse) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{11}
}

func (x *JoinRoomResponse) GetRepeatAt() *timestamppb.Timestamp {
	if x != nil {
		return x.RepeatAt
	}
	return nil
}

func (x *JoinRoomResponse) GetRoom() *RoomData {
	if x != nil {
		return x.Room
	}
	return nil
}

type LeaveRoomResponse struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *LeaveRoomResponse) Reset() {
	*x = LeaveRoomResponse{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[12]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *LeaveRoomResponse) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*LeaveRoomResponse) ProtoMessage() {}

func (x *LeaveRoomResponse) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[12]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use LeaveRoomResponse.ProtoReflect.Descriptor instead.
func (*LeaveRoomResponse) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{12}
}

type BanUserFromRoomRequest struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	UserId        string                 `protobuf:"bytes,1,opt,name=user_id,json=userId,proto3" json:"user_id,omitempty"`
	RoomId        string                 `protobuf:"bytes,2,opt,name=room_id,json=roomId,proto3" json:"room_id,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *BanUserFromRoomRequest) Reset() {
	*x = BanUserFromRoomRequest{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[13]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *BanUserFromRoomRequest) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*BanUserFromRoomRequest) ProtoMessage() {}

func (x *BanUserFromRoomRequest) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[13]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use BanUserFromRoomRequest.ProtoReflect.Descriptor instead.
func (*BanUserFromRoomRequest) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{13}
}

func (x *BanUserFromRoomRequest) GetUserId() string {
	if x != nil {
		return x.UserId
	}
	return ""
}

func (x *BanUserFromRoomRequest) GetRoomId() string {
	if x != nil {
		return x.RoomId
	}
	return ""
}

type BanUserFromRoomResponse struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *BanUserFromRoomResponse) Reset() {
	*x = BanUserFromRoomResponse{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[14]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *BanUserFromRoomResponse) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*BanUserFromRoomResponse) ProtoMessage() {}

func (x *BanUserFromRoomResponse) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[14]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use BanUserFromRoomResponse.ProtoReflect.Descriptor instead.
func (*BanUserFromRoomResponse) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{14}
}

type UnbanUserFromRoomRequest struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	UserId        string                 `protobuf:"bytes,1,opt,name=user_id,json=userId,proto3" json:"user_id,omitempty"`
	RoomId        string                 `protobuf:"bytes,2,opt,name=room_id,json=roomId,proto3" json:"room_id,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *UnbanUserFromRoomRequest) Reset() {
	*x = UnbanUserFromRoomRequest{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[15]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *UnbanUserFromRoomRequest) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*UnbanUserFromRoomRequest) ProtoMessage() {}

func (x *UnbanUserFromRoomRequest) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[15]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use UnbanUserFromRoomRequest.ProtoReflect.Descriptor instead.
func (*UnbanUserFromRoomRequest) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{15}
}

func (x *UnbanUserFromRoomRequest) GetUserId() string {
	if x != nil {
		return x.UserId
	}
	return ""
}

func (x *UnbanUserFromRoomRequest) GetRoomId() string {
	if x != nil {
		return x.RoomId
	}
	return ""
}

type UnbanUserFromRoomResponse struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *UnbanUserFromRoomResponse) Reset() {
	*x = UnbanUserFromRoomResponse{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[16]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *UnbanUserFromRoomResponse) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*UnbanUserFromRoomResponse) ProtoMessage() {}

func (x *UnbanUserFromRoomResponse) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[16]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use UnbanUserFromRoomResponse.ProtoReflect.Descriptor instead.
func (*UnbanUserFromRoomResponse) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{16}
}

type GetQuestionCountRequest struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	RoomId        string                 `protobuf:"bytes,1,opt,name=room_id,json=roomId,proto3" json:"room_id,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *GetQuestionCountRequest) Reset() {
	*x = GetQuestionCountRequest{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[17]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *GetQuestionCountRequest) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*GetQuestionCountRequest) ProtoMessage() {}

func (x *GetQuestionCountRequest) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[17]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use GetQuestionCountRequest.ProtoReflect.Descriptor instead.
func (*GetQuestionCountRequest) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{17}
}

func (x *GetQuestionCountRequest) GetRoomId() string {
	if x != nil {
		return x.RoomId
	}
	return ""
}

type GetQuestionCountResponse struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	Data          *QuestionCountData     `protobuf:"bytes,3,opt,name=data,proto3" json:"data,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *GetQuestionCountResponse) Reset() {
	*x = GetQuestionCountResponse{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[18]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *GetQuestionCountResponse) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*GetQuestionCountResponse) ProtoMessage() {}

func (x *GetQuestionCountResponse) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[18]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use GetQuestionCountResponse.ProtoReflect.Descriptor instead.
func (*GetQuestionCountResponse) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{18}
}

func (x *GetQuestionCountResponse) GetData() *QuestionCountData {
	if x != nil {
		return x.Data
	}
	return nil
}

type QuestionCountData struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	QuestionCount int32                  `protobuf:"varint,1,opt,name=question_count,json=questionCount,proto3" json:"question_count,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *QuestionCountData) Reset() {
	*x = QuestionCountData{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[19]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *QuestionCountData) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*QuestionCountData) ProtoMessage() {}

func (x *QuestionCountData) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[19]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use QuestionCountData.ProtoReflect.Descriptor instead.
func (*QuestionCountData) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{19}
}

func (x *QuestionCountData) GetQuestionCount() int32 {
	if x != nil {
		return x.QuestionCount
	}
	return 0
}

type StartMatchRequest struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	RoomId        string                 `protobuf:"bytes,1,opt,name=room_id,json=roomId,proto3" json:"room_id,omitempty"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *StartMatchRequest) Reset() {
	*x = StartMatchRequest{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[20]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *StartMatchRequest) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*StartMatchRequest) ProtoMessage() {}

func (x *StartMatchRequest) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[20]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use StartMatchRequest.ProtoReflect.Descriptor instead.
func (*StartMatchRequest) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{20}
}

func (x *StartMatchRequest) GetRoomId() string {
	if x != nil {
		return x.RoomId
	}
	return ""
}

type StartMatchResponse struct {
	state         protoimpl.MessageState `protogen:"open.v1"`
	unknownFields protoimpl.UnknownFields
	sizeCache     protoimpl.SizeCache
}

func (x *StartMatchResponse) Reset() {
	*x = StartMatchResponse{}
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[21]
	ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
	ms.StoreMessageInfo(mi)
}

func (x *StartMatchResponse) String() string {
	return protoimpl.X.MessageStringOf(x)
}

func (*StartMatchResponse) ProtoMessage() {}

func (x *StartMatchResponse) ProtoReflect() protoreflect.Message {
	mi := &file_gateway_rooms_v1_rooms_proto_msgTypes[21]
	if x != nil {
		ms := protoimpl.X.MessageStateOf(protoimpl.Pointer(x))
		if ms.LoadMessageInfo() == nil {
			ms.StoreMessageInfo(mi)
		}
		return ms
	}
	return mi.MessageOf(x)
}

// Deprecated: Use StartMatchResponse.ProtoReflect.Descriptor instead.
func (*StartMatchResponse) Descriptor() ([]byte, []int) {
	return file_gateway_rooms_v1_rooms_proto_rawDescGZIP(), []int{21}
}

var File_gateway_rooms_v1_rooms_proto protoreflect.FileDescriptor

var file_gateway_rooms_v1_rooms_proto_rawDesc = []byte{
	0x0a, 0x1c, 0x67, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x2f, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2f,
	0x76, 0x31, 0x2f, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x12, 0x10,
	0x67, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76, 0x31,
	0x1a, 0x1e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2f, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75,
	0x66, 0x2f, 0x64, 0x75, 0x72, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f,
	0x1a, 0x1f, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2f, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75,
	0x66, 0x2f, 0x74, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61, 0x6d, 0x70, 0x2e, 0x70, 0x72, 0x6f, 0x74,
	0x6f, 0x22, 0x29, 0x0a, 0x0e, 0x43, 0x72, 0x65, 0x61, 0x74, 0x65, 0x52, 0x6f, 0x6f, 0x6d, 0x44,
	0x61, 0x74, 0x61, 0x12, 0x17, 0x0a, 0x07, 0x72, 0x6f, 0x6f, 0x6d, 0x5f, 0x69, 0x64, 0x18, 0x01,
	0x20, 0x01, 0x28, 0x09, 0x52, 0x06, 0x72, 0x6f, 0x6f, 0x6d, 0x49, 0x64, 0x22, 0x27, 0x0a, 0x11,
	0x43, 0x72, 0x65, 0x61, 0x74, 0x65, 0x52, 0x6f, 0x6f, 0x6d, 0x52, 0x65, 0x71, 0x75, 0x65, 0x73,
	0x74, 0x12, 0x12, 0x0a, 0x04, 0x6e, 0x61, 0x6d, 0x65, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52,
	0x04, 0x6e, 0x61, 0x6d, 0x65, 0x22, 0x4a, 0x0a, 0x12, 0x43, 0x72, 0x65, 0x61, 0x74, 0x65, 0x52,
	0x6f, 0x6f, 0x6d, 0x52, 0x65, 0x73, 0x70, 0x6f, 0x6e, 0x73, 0x65, 0x12, 0x34, 0x0a, 0x04, 0x64,
	0x61, 0x74, 0x61, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x20, 0x2e, 0x67, 0x61, 0x74, 0x65,
	0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76, 0x31, 0x2e, 0x43, 0x72, 0x65,
	0x61, 0x74, 0x65, 0x52, 0x6f, 0x6f, 0x6d, 0x44, 0x61, 0x74, 0x61, 0x52, 0x04, 0x64, 0x61, 0x74,
	0x61, 0x22, 0x96, 0x02, 0x0a, 0x0f, 0x45, 0x64, 0x69, 0x74, 0x52, 0x6f, 0x6f, 0x6d, 0x52, 0x65,
	0x71, 0x75, 0x65, 0x73, 0x74, 0x12, 0x17, 0x0a, 0x07, 0x72, 0x6f, 0x6f, 0x6d, 0x5f, 0x69, 0x64,
	0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x06, 0x72, 0x6f, 0x6f, 0x6d, 0x49, 0x64, 0x12, 0x12,
	0x0a, 0x04, 0x6e, 0x61, 0x6d, 0x65, 0x18, 0x02, 0x20, 0x01, 0x28, 0x09, 0x52, 0x04, 0x6e, 0x61,
	0x6d, 0x65, 0x12, 0x1f, 0x0a, 0x0b, 0x6d, 0x61, 0x78, 0x5f, 0x70, 0x6c, 0x61, 0x79, 0x65, 0x72,
	0x73, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0d, 0x52, 0x0a, 0x6d, 0x61, 0x78, 0x50, 0x6c, 0x61, 0x79,
	0x65, 0x72, 0x73, 0x12, 0x45, 0x0a, 0x0e, 0x6d, 0x61, 0x74, 0x63, 0x68, 0x5f, 0x64, 0x75, 0x72,
	0x61, 0x74, 0x69, 0x6f, 0x6e, 0x18, 0x04, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x19, 0x2e, 0x67, 0x6f,
	0x6f, 0x67, 0x6c, 0x65, 0x2e, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e, 0x44, 0x75,
	0x72, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x48, 0x00, 0x52, 0x0d, 0x6d, 0x61, 0x74, 0x63, 0x68, 0x44,
	0x75, 0x72, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x88, 0x01, 0x01, 0x12, 0x41, 0x0a, 0x0a, 0x64, 0x69,
	0x66, 0x66, 0x69, 0x63, 0x75, 0x6c, 0x74, 0x79, 0x18, 0x05, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x21,
	0x2e, 0x67, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76,
	0x31, 0x2e, 0x44, 0x69, 0x66, 0x66, 0x69, 0x63, 0x75, 0x6c, 0x74, 0x79, 0x4c, 0x65, 0x76, 0x65,
	0x6c, 0x52, 0x0a, 0x64, 0x69, 0x66, 0x66, 0x69, 0x63, 0x75, 0x6c, 0x74, 0x79, 0x12, 0x18, 0x0a,
	0x07, 0x73, 0x68, 0x75, 0x66, 0x66, 0x6c, 0x65, 0x18, 0x06, 0x20, 0x01, 0x28, 0x08, 0x52, 0x07,
	0x73, 0x68, 0x75, 0x66, 0x66, 0x6c, 0x65, 0x42, 0x11, 0x0a, 0x0f, 0x5f, 0x6d, 0x61, 0x74, 0x63,
	0x68, 0x5f, 0x64, 0x75, 0x72, 0x61, 0x74, 0x69, 0x6f, 0x6e, 0x22, 0x12, 0x0a, 0x10, 0x45, 0x64,
	0x69, 0x74, 0x52, 0x6f, 0x6f, 0x6d, 0x52, 0x65, 0x73, 0x70, 0x6f, 0x6e, 0x73, 0x65, 0x22, 0x2a,
	0x0a, 0x0f, 0x4a, 0x6f, 0x69, 0x6e, 0x52, 0x6f, 0x6f, 0x6d, 0x52, 0x65, 0x71, 0x75, 0x65, 0x73,
	0x74, 0x12, 0x17, 0x0a, 0x07, 0x72, 0x6f, 0x6f, 0x6d, 0x5f, 0x69, 0x64, 0x18, 0x01, 0x20, 0x01,
	0x28, 0x09, 0x52, 0x06, 0x72, 0x6f, 0x6f, 0x6d, 0x49, 0x64, 0x22, 0x2b, 0x0a, 0x10, 0x4c, 0x65,
	0x61, 0x76, 0x65, 0x52, 0x6f, 0x6f, 0x6d, 0x52, 0x65, 0x71, 0x75, 0x65, 0x73, 0x74, 0x12, 0x17,
	0x0a, 0x07, 0x72, 0x6f, 0x6f, 0x6d, 0x5f, 0x69, 0x64, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52,
	0x06, 0x72, 0x6f, 0x6f, 0x6d, 0x49, 0x64, 0x22, 0x33, 0x0a, 0x18, 0x43, 0x68, 0x65, 0x63, 0x6b,
	0x49, 0x66, 0x52, 0x6f, 0x6f, 0x6d, 0x45, 0x78, 0x69, 0x73, 0x74, 0x73, 0x52, 0x65, 0x71, 0x75,
	0x65, 0x73, 0x74, 0x12, 0x17, 0x0a, 0x07, 0x72, 0x6f, 0x6f, 0x6d, 0x5f, 0x69, 0x64, 0x18, 0x01,
	0x20, 0x01, 0x28, 0x09, 0x52, 0x06, 0x72, 0x6f, 0x6f, 0x6d, 0x49, 0x64, 0x22, 0x33, 0x0a, 0x19,
	0x43, 0x68, 0x65, 0x63, 0x6b, 0x49, 0x66, 0x52, 0x6f, 0x6f, 0x6d, 0x45, 0x78, 0x69, 0x73, 0x74,
	0x73, 0x52, 0x65, 0x73, 0x70, 0x6f, 0x6e, 0x73, 0x65, 0x12, 0x16, 0x0a, 0x06, 0x65, 0x78, 0x69,
	0x73, 0x74, 0x73, 0x18, 0x01, 0x20, 0x01, 0x28, 0x08, 0x52, 0x06, 0x65, 0x78, 0x69, 0x73, 0x74,
	0x73, 0x22, 0x51, 0x0a, 0x04, 0x55, 0x73, 0x65, 0x72, 0x12, 0x17, 0x0a, 0x07, 0x75, 0x73, 0x65,
	0x72, 0x5f, 0x69, 0x64, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x06, 0x75, 0x73, 0x65, 0x72,
	0x49, 0x64, 0x12, 0x1a, 0x0a, 0x08, 0x6e, 0x69, 0x63, 0x6b, 0x6e, 0x61, 0x6d, 0x65, 0x18, 0x02,
	0x20, 0x01, 0x28, 0x09, 0x52, 0x08, 0x6e, 0x69, 0x63, 0x6b, 0x6e, 0x61, 0x6d, 0x65, 0x12, 0x14,
	0x0a, 0x05, 0x65, 0x6d, 0x6f, 0x6a, 0x69, 0x18, 0x03, 0x20, 0x01, 0x28, 0x09, 0x52, 0x05, 0x65,
	0x6d, 0x6f, 0x6a, 0x69, 0x22, 0xa7, 0x02, 0x0a, 0x08, 0x52, 0x6f, 0x6f, 0x6d, 0x44, 0x61, 0x74,
	0x61, 0x12, 0x12, 0x0a, 0x04, 0x6e, 0x61, 0x6d, 0x65, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52,
	0x04, 0x6e, 0x61, 0x6d, 0x65, 0x12, 0x17, 0x0a, 0x07, 0x68, 0x6f, 0x73, 0x74, 0x5f, 0x69, 0x64,
	0x18, 0x02, 0x20, 0x01, 0x28, 0x09, 0x52, 0x06, 0x68, 0x6f, 0x73, 0x74, 0x49, 0x64, 0x12, 0x1f,
	0x0a, 0x0b, 0x6d, 0x61, 0x78, 0x5f, 0x70, 0x6c, 0x61, 0x79, 0x65, 0x72, 0x73, 0x18, 0x03, 0x20,
	0x01, 0x28, 0x05, 0x52, 0x0a, 0x6d, 0x61, 0x78, 0x50, 0x6c, 0x61, 0x79, 0x65, 0x72, 0x73, 0x12,
	0x25, 0x0a, 0x0e, 0x71, 0x75, 0x65, 0x73, 0x74, 0x69, 0x6f, 0x6e, 0x5f, 0x63, 0x6f, 0x75, 0x6e,
	0x74, 0x18, 0x04, 0x20, 0x01, 0x28, 0x05, 0x52, 0x0d, 0x71, 0x75, 0x65, 0x73, 0x74, 0x69, 0x6f,
	0x6e, 0x43, 0x6f, 0x75, 0x6e, 0x74, 0x12, 0x3d, 0x0a, 0x0b, 0x72, 0x6f, 0x6f, 0x6d, 0x5f, 0x73,
	0x74, 0x61, 0x74, 0x75, 0x73, 0x18, 0x05, 0x20, 0x01, 0x28, 0x0e, 0x32, 0x1c, 0x2e, 0x67, 0x61,
	0x74, 0x65, 0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76, 0x31, 0x2e, 0x52,
	0x6f, 0x6f, 0x6d, 0x53, 0x74, 0x61, 0x74, 0x75, 0x73, 0x52, 0x0a, 0x72, 0x6f, 0x6f, 0x6d, 0x53,
	0x74, 0x61, 0x74, 0x75, 0x73, 0x12, 0x2c, 0x0a, 0x05, 0x75, 0x73, 0x65, 0x72, 0x73, 0x18, 0x06,
	0x20, 0x03, 0x28, 0x0b, 0x32, 0x16, 0x2e, 0x67, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x2e, 0x72,
	0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76, 0x31, 0x2e, 0x55, 0x73, 0x65, 0x72, 0x52, 0x05, 0x75, 0x73,
	0x65, 0x72, 0x73, 0x12, 0x39, 0x0a, 0x0c, 0x62, 0x61, 0x6e, 0x6e, 0x65, 0x64, 0x5f, 0x75, 0x73,
	0x65, 0x72, 0x73, 0x18, 0x07, 0x20, 0x03, 0x28, 0x0b, 0x32, 0x16, 0x2e, 0x67, 0x61, 0x74, 0x65,
	0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76, 0x31, 0x2e, 0x55, 0x73, 0x65,
	0x72, 0x52, 0x0b, 0x62, 0x61, 0x6e, 0x6e, 0x65, 0x64, 0x55, 0x73, 0x65, 0x72, 0x73, 0x22, 0x89,
	0x01, 0x0a, 0x10, 0x4a, 0x6f, 0x69, 0x6e, 0x52, 0x6f, 0x6f, 0x6d, 0x52, 0x65, 0x73, 0x70, 0x6f,
	0x6e, 0x73, 0x65, 0x12, 0x37, 0x0a, 0x09, 0x72, 0x65, 0x70, 0x65, 0x61, 0x74, 0x5f, 0x61, 0x74,
	0x18, 0x01, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1a, 0x2e, 0x67, 0x6f, 0x6f, 0x67, 0x6c, 0x65, 0x2e,
	0x70, 0x72, 0x6f, 0x74, 0x6f, 0x62, 0x75, 0x66, 0x2e, 0x54, 0x69, 0x6d, 0x65, 0x73, 0x74, 0x61,
	0x6d, 0x70, 0x52, 0x08, 0x72, 0x65, 0x70, 0x65, 0x61, 0x74, 0x41, 0x74, 0x12, 0x33, 0x0a, 0x04,
	0x72, 0x6f, 0x6f, 0x6d, 0x18, 0x02, 0x20, 0x01, 0x28, 0x0b, 0x32, 0x1a, 0x2e, 0x67, 0x61, 0x74,
	0x65, 0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76, 0x31, 0x2e, 0x52, 0x6f,
	0x6f, 0x6d, 0x44, 0x61, 0x74, 0x61, 0x48, 0x00, 0x52, 0x04, 0x72, 0x6f, 0x6f, 0x6d, 0x88, 0x01,
	0x01, 0x42, 0x07, 0x0a, 0x05, 0x5f, 0x72, 0x6f, 0x6f, 0x6d, 0x22, 0x13, 0x0a, 0x11, 0x4c, 0x65,
	0x61, 0x76, 0x65, 0x52, 0x6f, 0x6f, 0x6d, 0x52, 0x65, 0x73, 0x70, 0x6f, 0x6e, 0x73, 0x65, 0x22,
	0x4a, 0x0a, 0x16, 0x42, 0x61, 0x6e, 0x55, 0x73, 0x65, 0x72, 0x46, 0x72, 0x6f, 0x6d, 0x52, 0x6f,
	0x6f, 0x6d, 0x52, 0x65, 0x71, 0x75, 0x65, 0x73, 0x74, 0x12, 0x17, 0x0a, 0x07, 0x75, 0x73, 0x65,
	0x72, 0x5f, 0x69, 0x64, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x06, 0x75, 0x73, 0x65, 0x72,
	0x49, 0x64, 0x12, 0x17, 0x0a, 0x07, 0x72, 0x6f, 0x6f, 0x6d, 0x5f, 0x69, 0x64, 0x18, 0x02, 0x20,
	0x01, 0x28, 0x09, 0x52, 0x06, 0x72, 0x6f, 0x6f, 0x6d, 0x49, 0x64, 0x22, 0x19, 0x0a, 0x17, 0x42,
	0x61, 0x6e, 0x55, 0x73, 0x65, 0x72, 0x46, 0x72, 0x6f, 0x6d, 0x52, 0x6f, 0x6f, 0x6d, 0x52, 0x65,
	0x73, 0x70, 0x6f, 0x6e, 0x73, 0x65, 0x22, 0x4c, 0x0a, 0x18, 0x55, 0x6e, 0x62, 0x61, 0x6e, 0x55,
	0x73, 0x65, 0x72, 0x46, 0x72, 0x6f, 0x6d, 0x52, 0x6f, 0x6f, 0x6d, 0x52, 0x65, 0x71, 0x75, 0x65,
	0x73, 0x74, 0x12, 0x17, 0x0a, 0x07, 0x75, 0x73, 0x65, 0x72, 0x5f, 0x69, 0x64, 0x18, 0x01, 0x20,
	0x01, 0x28, 0x09, 0x52, 0x06, 0x75, 0x73, 0x65, 0x72, 0x49, 0x64, 0x12, 0x17, 0x0a, 0x07, 0x72,
	0x6f, 0x6f, 0x6d, 0x5f, 0x69, 0x64, 0x18, 0x02, 0x20, 0x01, 0x28, 0x09, 0x52, 0x06, 0x72, 0x6f,
	0x6f, 0x6d, 0x49, 0x64, 0x22, 0x1b, 0x0a, 0x19, 0x55, 0x6e, 0x62, 0x61, 0x6e, 0x55, 0x73, 0x65,
	0x72, 0x46, 0x72, 0x6f, 0x6d, 0x52, 0x6f, 0x6f, 0x6d, 0x52, 0x65, 0x73, 0x70, 0x6f, 0x6e, 0x73,
	0x65, 0x22, 0x32, 0x0a, 0x17, 0x47, 0x65, 0x74, 0x51, 0x75, 0x65, 0x73, 0x74, 0x69, 0x6f, 0x6e,
	0x43, 0x6f, 0x75, 0x6e, 0x74, 0x52, 0x65, 0x71, 0x75, 0x65, 0x73, 0x74, 0x12, 0x17, 0x0a, 0x07,
	0x72, 0x6f, 0x6f, 0x6d, 0x5f, 0x69, 0x64, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x06, 0x72,
	0x6f, 0x6f, 0x6d, 0x49, 0x64, 0x22, 0x53, 0x0a, 0x18, 0x47, 0x65, 0x74, 0x51, 0x75, 0x65, 0x73,
	0x74, 0x69, 0x6f, 0x6e, 0x43, 0x6f, 0x75, 0x6e, 0x74, 0x52, 0x65, 0x73, 0x70, 0x6f, 0x6e, 0x73,
	0x65, 0x12, 0x37, 0x0a, 0x04, 0x64, 0x61, 0x74, 0x61, 0x18, 0x03, 0x20, 0x01, 0x28, 0x0b, 0x32,
	0x23, 0x2e, 0x67, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e,
	0x76, 0x31, 0x2e, 0x51, 0x75, 0x65, 0x73, 0x74, 0x69, 0x6f, 0x6e, 0x43, 0x6f, 0x75, 0x6e, 0x74,
	0x44, 0x61, 0x74, 0x61, 0x52, 0x04, 0x64, 0x61, 0x74, 0x61, 0x22, 0x3a, 0x0a, 0x11, 0x51, 0x75,
	0x65, 0x73, 0x74, 0x69, 0x6f, 0x6e, 0x43, 0x6f, 0x75, 0x6e, 0x74, 0x44, 0x61, 0x74, 0x61, 0x12,
	0x25, 0x0a, 0x0e, 0x71, 0x75, 0x65, 0x73, 0x74, 0x69, 0x6f, 0x6e, 0x5f, 0x63, 0x6f, 0x75, 0x6e,
	0x74, 0x18, 0x01, 0x20, 0x01, 0x28, 0x05, 0x52, 0x0d, 0x71, 0x75, 0x65, 0x73, 0x74, 0x69, 0x6f,
	0x6e, 0x43, 0x6f, 0x75, 0x6e, 0x74, 0x22, 0x2c, 0x0a, 0x11, 0x53, 0x74, 0x61, 0x72, 0x74, 0x4d,
	0x61, 0x74, 0x63, 0x68, 0x52, 0x65, 0x71, 0x75, 0x65, 0x73, 0x74, 0x12, 0x17, 0x0a, 0x07, 0x72,
	0x6f, 0x6f, 0x6d, 0x5f, 0x69, 0x64, 0x18, 0x01, 0x20, 0x01, 0x28, 0x09, 0x52, 0x06, 0x72, 0x6f,
	0x6f, 0x6d, 0x49, 0x64, 0x22, 0x14, 0x0a, 0x12, 0x53, 0x74, 0x61, 0x72, 0x74, 0x4d, 0x61, 0x74,
	0x63, 0x68, 0x52, 0x65, 0x73, 0x70, 0x6f, 0x6e, 0x73, 0x65, 0x2a, 0x86, 0x01, 0x0a, 0x0f, 0x44,
	0x69, 0x66, 0x66, 0x69, 0x63, 0x75, 0x6c, 0x74, 0x79, 0x4c, 0x65, 0x76, 0x65, 0x6c, 0x12, 0x20,
	0x0a, 0x1c, 0x44, 0x49, 0x46, 0x46, 0x49, 0x43, 0x55, 0x4c, 0x54, 0x59, 0x5f, 0x4c, 0x45, 0x56,
	0x45, 0x4c, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43, 0x49, 0x46, 0x49, 0x45, 0x44, 0x10, 0x00,
	0x12, 0x19, 0x0a, 0x15, 0x44, 0x49, 0x46, 0x46, 0x49, 0x43, 0x55, 0x4c, 0x54, 0x59, 0x5f, 0x4c,
	0x45, 0x56, 0x45, 0x4c, 0x5f, 0x45, 0x41, 0x53, 0x59, 0x10, 0x01, 0x12, 0x1b, 0x0a, 0x17, 0x44,
	0x49, 0x46, 0x46, 0x49, 0x43, 0x55, 0x4c, 0x54, 0x59, 0x5f, 0x4c, 0x45, 0x56, 0x45, 0x4c, 0x5f,
	0x4d, 0x45, 0x44, 0x49, 0x55, 0x4d, 0x10, 0x02, 0x12, 0x19, 0x0a, 0x15, 0x44, 0x49, 0x46, 0x46,
	0x49, 0x43, 0x55, 0x4c, 0x54, 0x59, 0x5f, 0x4c, 0x45, 0x56, 0x45, 0x4c, 0x5f, 0x48, 0x41, 0x52,
	0x44, 0x10, 0x03, 0x2a, 0x8d, 0x01, 0x0a, 0x0a, 0x52, 0x6f, 0x6f, 0x6d, 0x53, 0x74, 0x61, 0x74,
	0x75, 0x73, 0x12, 0x1b, 0x0a, 0x17, 0x52, 0x4f, 0x4f, 0x4d, 0x5f, 0x53, 0x54, 0x41, 0x54, 0x55,
	0x53, 0x5f, 0x55, 0x4e, 0x53, 0x50, 0x45, 0x43, 0x49, 0x46, 0x49, 0x45, 0x44, 0x10, 0x00, 0x12,
	0x17, 0x0a, 0x13, 0x52, 0x4f, 0x4f, 0x4d, 0x5f, 0x53, 0x54, 0x41, 0x54, 0x55, 0x53, 0x5f, 0x57,
	0x41, 0x49, 0x54, 0x49, 0x4e, 0x47, 0x10, 0x01, 0x12, 0x18, 0x0a, 0x14, 0x52, 0x4f, 0x4f, 0x4d,
	0x5f, 0x53, 0x54, 0x41, 0x54, 0x55, 0x53, 0x5f, 0x53, 0x54, 0x41, 0x52, 0x54, 0x49, 0x4e, 0x47,
	0x10, 0x02, 0x12, 0x17, 0x0a, 0x13, 0x52, 0x4f, 0x4f, 0x4d, 0x5f, 0x53, 0x54, 0x41, 0x54, 0x55,
	0x53, 0x5f, 0x50, 0x4c, 0x41, 0x59, 0x49, 0x4e, 0x47, 0x10, 0x03, 0x12, 0x16, 0x0a, 0x12, 0x52,
	0x4f, 0x4f, 0x4d, 0x5f, 0x53, 0x54, 0x41, 0x54, 0x55, 0x53, 0x5f, 0x45, 0x4e, 0x44, 0x49, 0x4e,
	0x47, 0x10, 0x04, 0x32, 0xfd, 0x06, 0x0a, 0x0c, 0x52, 0x6f, 0x6f, 0x6d, 0x73, 0x53, 0x65, 0x72,
	0x76, 0x69, 0x63, 0x65, 0x12, 0x59, 0x0a, 0x0a, 0x43, 0x72, 0x65, 0x61, 0x74, 0x65, 0x52, 0x6f,
	0x6f, 0x6d, 0x12, 0x23, 0x2e, 0x67, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f,
	0x6d, 0x73, 0x2e, 0x76, 0x31, 0x2e, 0x43, 0x72, 0x65, 0x61, 0x74, 0x65, 0x52, 0x6f, 0x6f, 0x6d,
	0x52, 0x65, 0x71, 0x75, 0x65, 0x73, 0x74, 0x1a, 0x24, 0x2e, 0x67, 0x61, 0x74, 0x65, 0x77, 0x61,
	0x79, 0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76, 0x31, 0x2e, 0x43, 0x72, 0x65, 0x61, 0x74,
	0x65, 0x52, 0x6f, 0x6f, 0x6d, 0x52, 0x65, 0x73, 0x70, 0x6f, 0x6e, 0x73, 0x65, 0x22, 0x00, 0x12,
	0x53, 0x0a, 0x08, 0x45, 0x64, 0x69, 0x74, 0x52, 0x6f, 0x6f, 0x6d, 0x12, 0x21, 0x2e, 0x67, 0x61,
	0x74, 0x65, 0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76, 0x31, 0x2e, 0x45,
	0x64, 0x69, 0x74, 0x52, 0x6f, 0x6f, 0x6d, 0x52, 0x65, 0x71, 0x75, 0x65, 0x73, 0x74, 0x1a, 0x22,
	0x2e, 0x67, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76,
	0x31, 0x2e, 0x45, 0x64, 0x69, 0x74, 0x52, 0x6f, 0x6f, 0x6d, 0x52, 0x65, 0x73, 0x70, 0x6f, 0x6e,
	0x73, 0x65, 0x22, 0x00, 0x12, 0x53, 0x0a, 0x08, 0x4a, 0x6f, 0x69, 0x6e, 0x52, 0x6f, 0x6f, 0x6d,
	0x12, 0x21, 0x2e, 0x67, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73,
	0x2e, 0x76, 0x31, 0x2e, 0x4a, 0x6f, 0x69, 0x6e, 0x52, 0x6f, 0x6f, 0x6d, 0x52, 0x65, 0x71, 0x75,
	0x65, 0x73, 0x74, 0x1a, 0x22, 0x2e, 0x67, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f,
	0x6f, 0x6d, 0x73, 0x2e, 0x76, 0x31, 0x2e, 0x4a, 0x6f, 0x69, 0x6e, 0x52, 0x6f, 0x6f, 0x6d, 0x52,
	0x65, 0x73, 0x70, 0x6f, 0x6e, 0x73, 0x65, 0x22, 0x00, 0x12, 0x56, 0x0a, 0x09, 0x4c, 0x65, 0x61,
	0x76, 0x65, 0x52, 0x6f, 0x6f, 0x6d, 0x12, 0x22, 0x2e, 0x67, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79,
	0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76, 0x31, 0x2e, 0x4c, 0x65, 0x61, 0x76, 0x65, 0x52,
	0x6f, 0x6f, 0x6d, 0x52, 0x65, 0x71, 0x75, 0x65, 0x73, 0x74, 0x1a, 0x23, 0x2e, 0x67, 0x61, 0x74,
	0x65, 0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76, 0x31, 0x2e, 0x4c, 0x65,
	0x61, 0x76, 0x65, 0x52, 0x6f, 0x6f, 0x6d, 0x52, 0x65, 0x73, 0x70, 0x6f, 0x6e, 0x73, 0x65, 0x22,
	0x00, 0x12, 0x6e, 0x0a, 0x11, 0x43, 0x68, 0x65, 0x63, 0x6b, 0x49, 0x66, 0x52, 0x6f, 0x6f, 0x6d,
	0x45, 0x78, 0x69, 0x73, 0x74, 0x73, 0x12, 0x2a, 0x2e, 0x67, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79,
	0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76, 0x31, 0x2e, 0x43, 0x68, 0x65, 0x63, 0x6b, 0x49,
	0x66, 0x52, 0x6f, 0x6f, 0x6d, 0x45, 0x78, 0x69, 0x73, 0x74, 0x73, 0x52, 0x65, 0x71, 0x75, 0x65,
	0x73, 0x74, 0x1a, 0x2b, 0x2e, 0x67, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f,
	0x6d, 0x73, 0x2e, 0x76, 0x31, 0x2e, 0x43, 0x68, 0x65, 0x63, 0x6b, 0x49, 0x66, 0x52, 0x6f, 0x6f,
	0x6d, 0x45, 0x78, 0x69, 0x73, 0x74, 0x73, 0x52, 0x65, 0x73, 0x70, 0x6f, 0x6e, 0x73, 0x65, 0x22,
	0x00, 0x12, 0x68, 0x0a, 0x0f, 0x42, 0x61, 0x6e, 0x55, 0x73, 0x65, 0x72, 0x46, 0x72, 0x6f, 0x6d,
	0x52, 0x6f, 0x6f, 0x6d, 0x12, 0x28, 0x2e, 0x67, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x2e, 0x72,
	0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76, 0x31, 0x2e, 0x42, 0x61, 0x6e, 0x55, 0x73, 0x65, 0x72, 0x46,
	0x72, 0x6f, 0x6d, 0x52, 0x6f, 0x6f, 0x6d, 0x52, 0x65, 0x71, 0x75, 0x65, 0x73, 0x74, 0x1a, 0x29,
	0x2e, 0x67, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76,
	0x31, 0x2e, 0x42, 0x61, 0x6e, 0x55, 0x73, 0x65, 0x72, 0x46, 0x72, 0x6f, 0x6d, 0x52, 0x6f, 0x6f,
	0x6d, 0x52, 0x65, 0x73, 0x70, 0x6f, 0x6e, 0x73, 0x65, 0x22, 0x00, 0x12, 0x6e, 0x0a, 0x11, 0x55,
	0x6e, 0x62, 0x61, 0x6e, 0x55, 0x73, 0x65, 0x72, 0x46, 0x72, 0x6f, 0x6d, 0x52, 0x6f, 0x6f, 0x6d,
	0x12, 0x2a, 0x2e, 0x67, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73,
	0x2e, 0x76, 0x31, 0x2e, 0x55, 0x6e, 0x62, 0x61, 0x6e, 0x55, 0x73, 0x65, 0x72, 0x46, 0x72, 0x6f,
	0x6d, 0x52, 0x6f, 0x6f, 0x6d, 0x52, 0x65, 0x71, 0x75, 0x65, 0x73, 0x74, 0x1a, 0x2b, 0x2e, 0x67,
	0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76, 0x31, 0x2e,
	0x55, 0x6e, 0x62, 0x61, 0x6e, 0x55, 0x73, 0x65, 0x72, 0x46, 0x72, 0x6f, 0x6d, 0x52, 0x6f, 0x6f,
	0x6d, 0x52, 0x65, 0x73, 0x70, 0x6f, 0x6e, 0x73, 0x65, 0x22, 0x00, 0x12, 0x6b, 0x0a, 0x10, 0x47,
	0x65, 0x74, 0x51, 0x75, 0x65, 0x73, 0x74, 0x69, 0x6f, 0x6e, 0x43, 0x6f, 0x75, 0x6e, 0x74, 0x12,
	0x29, 0x2e, 0x67, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e,
	0x76, 0x31, 0x2e, 0x47, 0x65, 0x74, 0x51, 0x75, 0x65, 0x73, 0x74, 0x69, 0x6f, 0x6e, 0x43, 0x6f,
	0x75, 0x6e, 0x74, 0x52, 0x65, 0x71, 0x75, 0x65, 0x73, 0x74, 0x1a, 0x2a, 0x2e, 0x67, 0x61, 0x74,
	0x65, 0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76, 0x31, 0x2e, 0x47, 0x65,
	0x74, 0x51, 0x75, 0x65, 0x73, 0x74, 0x69, 0x6f, 0x6e, 0x43, 0x6f, 0x75, 0x6e, 0x74, 0x52, 0x65,
	0x73, 0x70, 0x6f, 0x6e, 0x73, 0x65, 0x22, 0x00, 0x12, 0x59, 0x0a, 0x0a, 0x53, 0x74, 0x61, 0x72,
	0x74, 0x4d, 0x61, 0x74, 0x63, 0x68, 0x12, 0x23, 0x2e, 0x67, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79,
	0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76, 0x31, 0x2e, 0x53, 0x74, 0x61, 0x72, 0x74, 0x4d,
	0x61, 0x74, 0x63, 0x68, 0x52, 0x65, 0x71, 0x75, 0x65, 0x73, 0x74, 0x1a, 0x24, 0x2e, 0x67, 0x61,
	0x74, 0x65, 0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76, 0x31, 0x2e, 0x53,
	0x74, 0x61, 0x72, 0x74, 0x4d, 0x61, 0x74, 0x63, 0x68, 0x52, 0x65, 0x73, 0x70, 0x6f, 0x6e, 0x73,
	0x65, 0x22, 0x00, 0x42, 0xd2, 0x01, 0x0a, 0x14, 0x63, 0x6f, 0x6d, 0x2e, 0x67, 0x61, 0x74, 0x65,
	0x77, 0x61, 0x79, 0x2e, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x76, 0x31, 0x42, 0x0a, 0x52, 0x6f,
	0x6f, 0x6d, 0x73, 0x50, 0x72, 0x6f, 0x74, 0x6f, 0x50, 0x01, 0x5a, 0x4c, 0x67, 0x69, 0x74, 0x6c,
	0x61, 0x62, 0x2e, 0x63, 0x6f, 0x6d, 0x2f, 0x62, 0x69, 0x6e, 0x61, 0x72, 0x79, 0x67, 0x61, 0x6d,
	0x65, 0x2f, 0x6d, 0x69, 0x63, 0x72, 0x6f, 0x73, 0x65, 0x72, 0x76, 0x69, 0x63, 0x65, 0x73, 0x2f,
	0x67, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x2f, 0x70, 0x6b, 0x67, 0x2f, 0x67, 0x65, 0x6e, 0x2f,
	0x67, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x2f, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x2f, 0x76, 0x31,
	0x3b, 0x72, 0x6f, 0x6f, 0x6d, 0x73, 0x76, 0x31, 0xa2, 0x02, 0x03, 0x47, 0x52, 0x58, 0xaa, 0x02,
	0x10, 0x47, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x2e, 0x52, 0x6f, 0x6f, 0x6d, 0x73, 0x2e, 0x56,
	0x31, 0xca, 0x02, 0x10, 0x47, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x5c, 0x52, 0x6f, 0x6f, 0x6d,
	0x73, 0x5c, 0x56, 0x31, 0xe2, 0x02, 0x1c, 0x47, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x5c, 0x52,
	0x6f, 0x6f, 0x6d, 0x73, 0x5c, 0x56, 0x31, 0x5c, 0x47, 0x50, 0x42, 0x4d, 0x65, 0x74, 0x61, 0x64,
	0x61, 0x74, 0x61, 0xea, 0x02, 0x12, 0x47, 0x61, 0x74, 0x65, 0x77, 0x61, 0x79, 0x3a, 0x3a, 0x52,
	0x6f, 0x6f, 0x6d, 0x73, 0x3a, 0x3a, 0x56, 0x31, 0x62, 0x06, 0x70, 0x72, 0x6f, 0x74, 0x6f, 0x33,
}

var (
	file_gateway_rooms_v1_rooms_proto_rawDescOnce sync.Once
	file_gateway_rooms_v1_rooms_proto_rawDescData = file_gateway_rooms_v1_rooms_proto_rawDesc
)

func file_gateway_rooms_v1_rooms_proto_rawDescGZIP() []byte {
	file_gateway_rooms_v1_rooms_proto_rawDescOnce.Do(func() {
		file_gateway_rooms_v1_rooms_proto_rawDescData = protoimpl.X.CompressGZIP(file_gateway_rooms_v1_rooms_proto_rawDescData)
	})
	return file_gateway_rooms_v1_rooms_proto_rawDescData
}

var file_gateway_rooms_v1_rooms_proto_enumTypes = make([]protoimpl.EnumInfo, 2)
var file_gateway_rooms_v1_rooms_proto_msgTypes = make([]protoimpl.MessageInfo, 22)
var file_gateway_rooms_v1_rooms_proto_goTypes = []any{
	(DifficultyLevel)(0),              // 0: gateway.rooms.v1.DifficultyLevel
	(RoomStatus)(0),                   // 1: gateway.rooms.v1.RoomStatus
	(*CreateRoomData)(nil),            // 2: gateway.rooms.v1.CreateRoomData
	(*CreateRoomRequest)(nil),         // 3: gateway.rooms.v1.CreateRoomRequest
	(*CreateRoomResponse)(nil),        // 4: gateway.rooms.v1.CreateRoomResponse
	(*EditRoomRequest)(nil),           // 5: gateway.rooms.v1.EditRoomRequest
	(*EditRoomResponse)(nil),          // 6: gateway.rooms.v1.EditRoomResponse
	(*JoinRoomRequest)(nil),           // 7: gateway.rooms.v1.JoinRoomRequest
	(*LeaveRoomRequest)(nil),          // 8: gateway.rooms.v1.LeaveRoomRequest
	(*CheckIfRoomExistsRequest)(nil),  // 9: gateway.rooms.v1.CheckIfRoomExistsRequest
	(*CheckIfRoomExistsResponse)(nil), // 10: gateway.rooms.v1.CheckIfRoomExistsResponse
	(*User)(nil),                      // 11: gateway.rooms.v1.User
	(*RoomData)(nil),                  // 12: gateway.rooms.v1.RoomData
	(*JoinRoomResponse)(nil),          // 13: gateway.rooms.v1.JoinRoomResponse
	(*LeaveRoomResponse)(nil),         // 14: gateway.rooms.v1.LeaveRoomResponse
	(*BanUserFromRoomRequest)(nil),    // 15: gateway.rooms.v1.BanUserFromRoomRequest
	(*BanUserFromRoomResponse)(nil),   // 16: gateway.rooms.v1.BanUserFromRoomResponse
	(*UnbanUserFromRoomRequest)(nil),  // 17: gateway.rooms.v1.UnbanUserFromRoomRequest
	(*UnbanUserFromRoomResponse)(nil), // 18: gateway.rooms.v1.UnbanUserFromRoomResponse
	(*GetQuestionCountRequest)(nil),   // 19: gateway.rooms.v1.GetQuestionCountRequest
	(*GetQuestionCountResponse)(nil),  // 20: gateway.rooms.v1.GetQuestionCountResponse
	(*QuestionCountData)(nil),         // 21: gateway.rooms.v1.QuestionCountData
	(*StartMatchRequest)(nil),         // 22: gateway.rooms.v1.StartMatchRequest
	(*StartMatchResponse)(nil),        // 23: gateway.rooms.v1.StartMatchResponse
	(*durationpb.Duration)(nil),       // 24: google.protobuf.Duration
	(*timestamppb.Timestamp)(nil),     // 25: google.protobuf.Timestamp
}
var file_gateway_rooms_v1_rooms_proto_depIdxs = []int32{
	2,  // 0: gateway.rooms.v1.CreateRoomResponse.data:type_name -> gateway.rooms.v1.CreateRoomData
	24, // 1: gateway.rooms.v1.EditRoomRequest.match_duration:type_name -> google.protobuf.Duration
	0,  // 2: gateway.rooms.v1.EditRoomRequest.difficulty:type_name -> gateway.rooms.v1.DifficultyLevel
	1,  // 3: gateway.rooms.v1.RoomData.room_status:type_name -> gateway.rooms.v1.RoomStatus
	11, // 4: gateway.rooms.v1.RoomData.users:type_name -> gateway.rooms.v1.User
	11, // 5: gateway.rooms.v1.RoomData.banned_users:type_name -> gateway.rooms.v1.User
	25, // 6: gateway.rooms.v1.JoinRoomResponse.repeat_at:type_name -> google.protobuf.Timestamp
	12, // 7: gateway.rooms.v1.JoinRoomResponse.room:type_name -> gateway.rooms.v1.RoomData
	21, // 8: gateway.rooms.v1.GetQuestionCountResponse.data:type_name -> gateway.rooms.v1.QuestionCountData
	3,  // 9: gateway.rooms.v1.RoomsService.CreateRoom:input_type -> gateway.rooms.v1.CreateRoomRequest
	5,  // 10: gateway.rooms.v1.RoomsService.EditRoom:input_type -> gateway.rooms.v1.EditRoomRequest
	7,  // 11: gateway.rooms.v1.RoomsService.JoinRoom:input_type -> gateway.rooms.v1.JoinRoomRequest
	8,  // 12: gateway.rooms.v1.RoomsService.LeaveRoom:input_type -> gateway.rooms.v1.LeaveRoomRequest
	9,  // 13: gateway.rooms.v1.RoomsService.CheckIfRoomExists:input_type -> gateway.rooms.v1.CheckIfRoomExistsRequest
	15, // 14: gateway.rooms.v1.RoomsService.BanUserFromRoom:input_type -> gateway.rooms.v1.BanUserFromRoomRequest
	17, // 15: gateway.rooms.v1.RoomsService.UnbanUserFromRoom:input_type -> gateway.rooms.v1.UnbanUserFromRoomRequest
	19, // 16: gateway.rooms.v1.RoomsService.GetQuestionCount:input_type -> gateway.rooms.v1.GetQuestionCountRequest
	22, // 17: gateway.rooms.v1.RoomsService.StartMatch:input_type -> gateway.rooms.v1.StartMatchRequest
	4,  // 18: gateway.rooms.v1.RoomsService.CreateRoom:output_type -> gateway.rooms.v1.CreateRoomResponse
	6,  // 19: gateway.rooms.v1.RoomsService.EditRoom:output_type -> gateway.rooms.v1.EditRoomResponse
	13, // 20: gateway.rooms.v1.RoomsService.JoinRoom:output_type -> gateway.rooms.v1.JoinRoomResponse
	14, // 21: gateway.rooms.v1.RoomsService.LeaveRoom:output_type -> gateway.rooms.v1.LeaveRoomResponse
	10, // 22: gateway.rooms.v1.RoomsService.CheckIfRoomExists:output_type -> gateway.rooms.v1.CheckIfRoomExistsResponse
	16, // 23: gateway.rooms.v1.RoomsService.BanUserFromRoom:output_type -> gateway.rooms.v1.BanUserFromRoomResponse
	18, // 24: gateway.rooms.v1.RoomsService.UnbanUserFromRoom:output_type -> gateway.rooms.v1.UnbanUserFromRoomResponse
	20, // 25: gateway.rooms.v1.RoomsService.GetQuestionCount:output_type -> gateway.rooms.v1.GetQuestionCountResponse
	23, // 26: gateway.rooms.v1.RoomsService.StartMatch:output_type -> gateway.rooms.v1.StartMatchResponse
	18, // [18:27] is the sub-list for method output_type
	9,  // [9:18] is the sub-list for method input_type
	9,  // [9:9] is the sub-list for extension type_name
	9,  // [9:9] is the sub-list for extension extendee
	0,  // [0:9] is the sub-list for field type_name
}

func init() { file_gateway_rooms_v1_rooms_proto_init() }
func file_gateway_rooms_v1_rooms_proto_init() {
	if File_gateway_rooms_v1_rooms_proto != nil {
		return
	}
	file_gateway_rooms_v1_rooms_proto_msgTypes[3].OneofWrappers = []any{}
	file_gateway_rooms_v1_rooms_proto_msgTypes[11].OneofWrappers = []any{}
	type x struct{}
	out := protoimpl.TypeBuilder{
		File: protoimpl.DescBuilder{
			GoPackagePath: reflect.TypeOf(x{}).PkgPath(),
			RawDescriptor: file_gateway_rooms_v1_rooms_proto_rawDesc,
			NumEnums:      2,
			NumMessages:   22,
			NumExtensions: 0,
			NumServices:   1,
		},
		GoTypes:           file_gateway_rooms_v1_rooms_proto_goTypes,
		DependencyIndexes: file_gateway_rooms_v1_rooms_proto_depIdxs,
		EnumInfos:         file_gateway_rooms_v1_rooms_proto_enumTypes,
		MessageInfos:      file_gateway_rooms_v1_rooms_proto_msgTypes,
	}.Build()
	File_gateway_rooms_v1_rooms_proto = out.File
	file_gateway_rooms_v1_rooms_proto_rawDesc = nil
	file_gateway_rooms_v1_rooms_proto_goTypes = nil
	file_gateway_rooms_v1_rooms_proto_depIdxs = nil
}
